<?php
require_once '../../../utils/constants.php';
require_once('../../../Db/dbconfig.php');

$status = false;

$error_code = 400;

$msg = '';

$validParams = false;
error_log(print_r('Api search Start', TRUE));
error_log(print_r($_GET, TRUE));

if(!isset($_GET['search_text'])){
	$msg = 'search_text parameter missing';
}else{
	$validParams = true;
}

if($validParams){

    $room_array = array();

	$sql = "select r.id from rooms r where r.started =1 and (r.name like '%".$_GET['search_text']."%' or r.description like '%".$_GET['search_text']."%')";

	$res=mysqli_query($con,$sql);
	if (mysqli_num_rows($res) > 0){

        $sql = "select r.id, r.name, r.creator, r.status, r.description, r.started_on, r.started,r.avion_room_id,
                (select c.name from clubs_room cr,clubs c where c.id = cr.club_id and cr.room_id = r.id) as club_name,
                (select cr.tickets from clubs_room cr,clubs c where c.id = cr.club_id and cr.room_id = r.id) as tickets,
                (select count(id) from rooms_member rm where rm.room_id = r.id) as participants_count from rooms r
                where r.started =1 and (r.name like '%".$_GET['search_text']."%' or r.description like '%".$_GET['search_text']."%')";

        $res=mysqli_query($con,$sql);
        if (mysqli_num_rows($res) > 0){
            while($rows=mysqli_fetch_assoc($res)){

                $sql_user = "select u.user_name ,u.user_icon from rooms_member rm, users u where rm.user_id = u.id and rm.room_id = ".$rows['id']." limit 3";

                $top_paritcipants = array();

                $res_user=mysqli_query($con,$sql_user);
                if (mysqli_num_rows($res_user) > 0){
                    while($rows_user=mysqli_fetch_assoc($res_user)){
                        $room_members = ["user_name"=>$rows_user['user_name'],"user_image"=>$rows_user['user_icon']];
                        array_push($top_paritcipants,$room_members);
                    }
                }
                
                $room = ['id'=>$rows['id'],'name'=> $rows['name'],'description'=>$rows['description'],'status'=>$rows['status'],'avion_room_id'=>$rows['avion_room_id'],'started_on'=> $rows['started_on'],
                'creator'=>(int)$rows['creator'],'participants_count'=>(int)$rows['participants_count'],'started'=>true,'club_name'=>$rows['club_name'] == null ? '' : $rows['club_name'],'top_participants'=>$top_paritcipants,'tickets'=>(int)$rows['tickets']];

                array_push($room_array,$room);
            }

            $room_list = ["room_list"=>$room_array];
        }
			
    }

    $error_code = 200;
    $status = true;
    $msg = "Success";
}

if($status){
	$myObj = [ 'status' => $status,'message'=> $msg,'data'=> $room_list];	
}else{
	$myObj = [ 'status' => $status,'message'=> $msg];
}

error_log(print_r($myObj, TRUE));
error_log(print_r('Api search Stop', TRUE));

mysqli_close($con);
header('Content-type: application/json');
http_response_code($error_code);
echo json_encode($myObj);

?>