<?php
require_once '../../../utils/constants.php';
require_once('../../../Db/dbconfig.php');

$status = false;

$error_code = 400;

$msg = '';

$validParams = false;

error_log(print_r('Api getUserById Start', TRUE));
error_log(print_r($_GET, TRUE));

if(!isset($_GET['id'])){
	$msg = 'id parameter missing';
}else if(!isset($_GET['requesting_user_id'])){
	$msg = 'requesting_user_id parameter missing';
}else{
	$validParams = true;
}
	
if($validParams){
	$uid = $_GET['id'];
	$sql = "select u.`id`, u.`uid`, u.`first_name`, u.`last_name`, u.`user_name`, u.`email`, u.`dob`, u.`contact_no`, u.`social_links`, u.`joined_on`, u.`bio`
, u.`status`, u.`user_icon`, if((select count(*) from user_follower uf where uf.user_id =".$_GET['requesting_user_id']." and uf.follower_id = u.id)>0,true,false) as is_following,
(select group_concat(ui.interest) from user_interest ui where ui.uid = u.id) as interest,
(select count(*) from user_follower uf where uf.follower_id = u.id) as following,(select count(*) from user_follower uf where uf.user_id = u.id) as followers
from users u where u.id=".$uid;

	$res=mysqli_query($con,$sql);
	if (mysqli_num_rows($res) > 0){

		while($rows=mysqli_fetch_assoc($res)){
			$status = true;
			$error_code = 200;

			if($rows['interest'] !=null or !empty($rows['interest'])){
				$interest_list_str = explode(',',$rows['interest']);
				$interest_list = array_map('intval', $interest_list_str);
			}else{
				$interest_list = array();
			}

			$user = ['id'=>(int)$rows['id'],'first_name'=> $rows['first_name'],'last_name'=>$rows['last_name'],'user_icon'=>$rows['user_icon'],'user_name'=> $rows['user_name'],
			'email'=>$rows['email'],'dob'=>$rows['dob'],'contact_no'=>$rows['contact_no'],'is_following'=>filter_var($rows['is_following'], FILTER_VALIDATE_BOOLEAN),
			'following'=>(int)$rows['following'],'followers'=>(int)$rows['followers'],'interest'=> $interest_list,'social_links'=>$rows['social_links'],'bio'=>$rows['bio']];

			$msg = 'User Data retrieved successfully';
		}
	}else{
		$error_code = 404;

		$msg = 'User not found';
	}
}

if($status){
	$myObj = [ 'status' => $status,'message'=> $msg,'data'=> $user];
}else{
	$myObj = [ 'status' => $status,'message'=> $msg];
}

error_log(print_r($myObj, TRUE));
error_log(print_r('Api getUserById Stop', TRUE));

mysqli_close($con);
header('Content-type: application/json');
http_response_code($error_code);
echo json_encode($myObj);

?>